import 'dart:convert';

class AppConfig {
  final String clientToken;
  final String clientSecretKey;
  final String clientCountry;
  final String clientDomain;
  final String clientPublisherApiToken;

  AppConfig(
      {this.clientToken,
      this.clientSecretKey,
      this.clientCountry,
      this.clientDomain,
      this.clientPublisherApiToken});

  static AppConfig loadAsJsonString(String contents) {
    try {
      if (contents == null || contents.isEmpty) {
        throw new Exception('contents can not be null');
      }
      // decode the json
      final json = jsonDecode(contents);
      // convert the JSON into an instance of AppConfig class
      return AppConfig(
          clientToken: json['com.dcoupon.sdk.ClientToken'],
          clientSecretKey: json['com.dcoupon.sdk.ClientSecretKey'],
          clientCountry: json['com.dcoupon.sdk.ClientCountry'],
          clientDomain: json['com.dcoupon.sdk.ClientDomain'],
          clientPublisherApiToken:
              json['com.dcoupon.sdk.ClientPublisherApiToken']);
    } catch (ex) {
      print('loadAsJsonString: ' + ex.toString());
      return null;
    }
  }

  AppConfig.fromJson(Map<dynamic, dynamic> json)
      : clientToken = json['clientToken'],
        clientSecretKey = json['clientSecretKey'],
        clientCountry = json['clientCountry'],
        clientDomain = json['clientDomain'],
        clientPublisherApiToken = json['clientPublisherApiToken'];

  Map<dynamic, dynamic> toJson() => {
        'clientToken': clientToken,
        'clientSecretKey': clientSecretKey,
        'clientCountry': clientCountry,
        'clientDomain': clientDomain,
        'clientPublisherApiToken': clientPublisherApiToken,
      };
}
