import 'dart:io';

import 'package:dcoupon_sdk_flutter_plugin/dcoupon_sdk_flutter_plugin.dart';
import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  TestWidgetsFlutterBinding.ensureInitialized();
  Dcoupon dcoupon;
  Future<String> loadString() async{
    var contents = await rootBundle.loadString('test.json');
    return contents;
  }
  setUp(() {
    dcoupon = new Dcoupon(null);
    dcoupon.loadConfig(new File('test.json').readAsStringSync());
    /*loadString().then((onValue){
      dcoupon.loadConfig(onValue);
    });*/
    dcoupon.setJwt("mocked_jwt");
    dcoupon.setClientType("mocked_clientType");
    dcoupon.setIsLogged(true);
  });

  tearDown(() {});

  test('login', () async {
    dcoupon
        .login('mocked@mocked.com', 'mocked',
            alias: 'mocked', gender: 'mocked', birthdate: 'YYYY-MM-dd')
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getCoupons', () async {
    dcoupon
        .getCoupons(start: 0, limit: 0, sortBy: null)
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getCouponDetail', () async {
    dcoupon.getCouponDetail(0).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('activateCoupon', () async {
    dcoupon.activateCoupon(0).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('deactivateCoupon', () async {
    dcoupon.deactivateCoupon(0).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });
  test('getRedemptionCode', () async {
    dcoupon.getRedemptionCode().then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('createCoupons', () async {
    dcoupon.createCoupons(['mocked', 'mocked'],
        latitude: null,
        longitude: null,
        source: null,
        transId: null,
        crmId: null).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getFilters', () async {
    dcoupon.getFilters(start: 0, limit: 0).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getPromotions', () async {
    dcoupon
        .getPromotions(
            start: 0,
            limit: 0,
            categoryIds: null,
            storeIds: null,
            retailerTokens: null,
            companyTokens: null,
            textSearch: null,
            zipcode: null,
            latitude: null,
            longitude: null,
            radius: null,
            orderBy: null)
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getPromotionDetail', () async {
    dcoupon.getPromotionDetail(null).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getStores', () async {
    dcoupon
        .getStores(
            start: 0,
            limit: 0,
            promotionToken: null,
            retailerTokens: null,
            zipcode: null,
            latitude: null,
            longitude: null,
            radius: null)
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  testWidgets("Empty widget test", (tester) async {});
}
